﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DecratorPatternCode
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("小二哥，来一杯矿泉水加糖");

            MineralWater mineralWater = new MineralWater();
            Sugar sugar = new Sugar(mineralWater);
            Console.WriteLine("客官，来了，请慢用");
            Console.WriteLine(sugar.GetDesciption());
            Console.WriteLine("小二哥，结账");

            Console.WriteLine("客官，共"+sugar.Cost()+"￥");
            Console.WriteLine("客官慢走");


            Console.WriteLine("----------------------------");


            Console.WriteLine("小二哥，来一杯矿泉水加糖");

            MineralWater mineralWater1 = new MineralWater();
            Sugar sugar1 = new Sugar(mineralWater1);
            BeverageExtend beverage = new BeverageExtend(sugar1);
            Console.WriteLine("客官，来了，请慢用");
            Console.WriteLine(beverage.GetDesciption());
            Console.WriteLine("小二哥，结账");

            Console.WriteLine("客官，共" + beverage.Cost() + "￥");
            Console.WriteLine("客官慢走");
            Console.WriteLine("----------------------------");


            Console.WriteLine("小二哥，来一杯咖啡加牛奶");

            Coffee coffee = new Coffee();
            Milk milk = new Milk(coffee);

            BeverageExtend beverage2 = new BeverageExtend(milk);
            
            Console.WriteLine("客官，来了，请慢用");
            Console.WriteLine(beverage2.GetDesciption());
            Console.WriteLine("小二哥，结账");

            Console.WriteLine("客官，共" +beverage2.Cost() + "￥");
            Console.WriteLine("客官慢走");

            Console.ReadKey();
        }
    }
}
